#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include "sort.h"
#include "mytime.h"

#define BUFSIZE (1024)

int
main(int argc, char *argv[])
{
    // arguments
    char *inFile = argv[1];

    int fd = open(inFile, O_RDONLY);
    assert(fd >= 0);

    double t1 = Time_GetSeconds();

    rec_t *record = malloc(BUFSIZE * sizeof(rec_t));
    assert(record != NULL);
    int count = 0;
    while (1) {	
	int rc;
	rc = read(fd, record, BUFSIZE * sizeof(rec_t));
	if (rc == 0)
	    break;
	assert(rc > 0);
	count += (rc / sizeof(rec_t));
    }
    (void) close(fd);

    double t2 = Time_GetSeconds();

    printf("Read %d records in %.2f seconds [%.2f MB @ %.2f MB/s]\n", count, t2-t1, (float)(count * sizeof(rec_t))/(1024.0*1024.0), 
	   (float)(count * sizeof(rec_t)) / ((t2-t1) * 1024.0 * 1024.0));

    return 0;
}

